import { PrismaClient } from "@prisma/client";

const prisma = new PrismaClient();
const authors = [
  {
    firstname: "J. R. R.",
    lastname: "Tolkien",
    books: {
      create: [
        {
          title: "Livre savane",
          tags: {
            create: [{ name: "tag1" }, { name: "tag2" }],
          },
        },
        {
          title: "Livre desert",
        },
      ],
    },
  },
  {
    firstname: "H. P.",
    lastname: "Lovecraft",
    books: {
      create: [
        { title: "Livre glace", },
      ],
    },
  },
];

async function main() {
    for(const author of authors) {
        await prisma.author.create({
            data: author
        });
    }

    for (let i = 0; i < 10; i+=1){
      const author = {
        lastname : i.toString(),
        firstname : i.toString(),
      }
      await prisma.author.create({data: author})
    }
}

main()
  .then(async () => {
    await prisma.$disconnect();
  })
  .catch(async (e) => {
    console.error(e);
    await prisma.$disconnect();
    process.exit(1);
  });
