import { Response } from "express";

export function responde(res : Response, statusCode : number, message : String, custom_object : Object | undefined = undefined) {
    if (custom_object) {
        res.status(statusCode).json({ status: message, object: custom_object });
    } else {
        res.status(statusCode).json({ status: message});
    }
}

export function getAllEndpoints(app: any) {
  const routes: any = [];

  // Iterate through each layer of the router stack
  app._router.stack.forEach((middleware: any) => {
    if (middleware.route) {
      // Routes registered directly on the app
      routes.push({
        method: Object.keys(middleware.route.methods)[0].toUpperCase(),
        path: middleware.route.path,
      });
    } else if (middleware.name === "router") {
      // Routes registered on routers
      middleware.handle.stack.forEach((handler: any) => {
        routes.push({
          method: Object.keys(handler.route.methods)[0].toUpperCase(),
          path: middleware.regexp.toString() + handler.route.path,
        });
      });
    }
  });

  return routes;
}