import express, { Request, Response, NextFunction } from 'express';
import { getAllEndpoints } from './functions';
import { StructError } from 'superstruct';


const app = express();
const port = 3000;

app.use(express.json());

app.use('/api', require('./routes/routes_controller'));


app.listen(port, () => {
  console.log(`Example app listening on port ${port}`);
});
app.get("/routes", (req: Request, res: Response) => {
  res.json(getAllEndpoints(app));
});

app.use((err: Error, req: Request, res: Response, next : NextFunction) => {
  if (err instanceof StructError) {
    res.status(400).json({ status: "Bad arguments."});
  } else {
    // const ERROR_DATA = JSON.parse(err.message)
    // res.status(ERROR_DATA['status']).json({ status: ERROR_DATA['message']});
    res.status(500).json({status:"Internal error"})
  }
});