import express, { Request, Response, NextFunction } from 'express';
import { HttpError } from './error';
import { StructError } from 'superstruct';

const app = express();
const port = 3000;

app.use(express.json());

app.use("/api", require("./routes/routes_controller"));

app.use((err: HttpError, req: Request, res: Response, next: NextFunction) => {
  if (err instanceof StructError) {
    err.status = 400;
    err.message = `Bad value for field ${err.key}`;
  }
  return res.status(err.status ?? 500).send(err.message);
});

app.listen(port, () => {
  console.log(`App listening on port ${port}`);
});
