import { object, string, optional, size, refine, partial, array, integer } from 'superstruct';
import { isEmail } from 'validator';
import { ProjectCreationData } from './project';


export const UserCreationData = object({
    email: refine(string(), 'Email', (value) => isEmail(value)),
    username: optional(string()),
    // createdProjects: optional(array(integer())),
    // assignedTasks: optional(array(integer()))
});

export const UserUpdateData = partial(UserCreationData);
